/*
 *  Copyright (C) 2008-2010 WaveMaker Software, Inc.
 *
 *  This file is part of the WaveMaker Client Runtime.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
dojo.provide("wm.base.widget.dijit.Calendar");
dojo.require("wm.base.lib.date");
dojo.require("wm.base.widget.dijit.Dijit");
dojo.require("dijit._Calendar");
dojo.require("dojo.date.locale");

dojo.declare("wm.dijit.Calendar", wm.Dijit, {
	displayDate: "",
	dijitClass: dijit._Calendar,
	width: "360px",
	height: "160px",
	setDomNode: function() {
		this.inherited(arguments);
		var s = this.dijit.domNode.style;
		s.width = s.height = "100%";
	},
	setDate: function(inValue) {
		this.dijit.setValue(wm.convertValueToDate(inValue));
	},
	getDisplayDate: function() {
		return dojo.date.locale.format(this.dijit.value, { selector: "date"});
	},
	setDisplayDate: function(inValue) {
		this.setDate(inValue);
	},
	getDateValue: function() {
		// dijit._Calendar doesn't have a getValue()
		var v = this.dijit.value;
		return v instanceof Date ? v.getTime() : null;
	},
	setDateValue: function(inValue) {
		this.setDate(inValue);
	},
	onValueSelected: function(inDate) {
		this.setValue("dateValue", inDate instanceof Date ? inDate.getTime() : null);
	}
});

wm.Object.extendSchema(wm.dijit.Calendar, {
	disabled: {ignore: 1},
	dateValue: { ignore: 1, bindable: 1, type: "Date" }
});

wm.dijit.Calendar.description = "A monthly calendar.";
