/*
 * Copyright (C) 2009-2010 WaveMaker Software, Inc.
 *
 * This file is part of WaveMaker Studio.
 *
 * WaveMaker Studio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, version 3 of the License, only.
 *
 * WaveMaker Studio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with WaveMaker Studio.  If not, see <http://www.gnu.org/licenses/>.
 */ 
Studio.widgets = {
	studioService: ["wm.JsonRpcService", {service: "studioService", sync: true}, {}],
	servicesService: ["wm.JsonRpcService", {service: "servicesService", sync: true}, {}],
	pagesService: ["wm.JsonRpcService", {service: "pagesService", sync: true}, {}],
	deploymentService: ["wm.JsonRpcService", {service: "deploymentService", sync: true}, {}],
	dataService: ["wm.JsonRpcService", {service: "dataService", sync: true}, {}],
	runtimeService: ["wm.JsonRpcService", {service: "runtimeService", sync: true}, {}],
	webService: ["wm.JsonRpcService", {service: "webService", sync: true}, {}],
	javaService: ["wm.JsonRpcService", {service: "javaService", sync: true}, {}],
	securityConfigService: ["wm.JsonRpcService", {service: "securityConfigService", sync: true}, {}],
	securityService: ["wm.JsonRpcService", {service: "securityService", sync: true}, {}, {}],
	securityServiceJOSSO: ["wm.JsonRpcService", {service: "securityServiceJOSSO", sync: true}, {}, {}],
	//registrationService: ["wm.JsonRpcService", {service: "registrationService", sync: true}, {}],
	UserService: ["wm.JsonRpcService", {service: "UserService", sync: true}, {}],
	resourceManagerService: ["wm.JsonRpcService", {service: "resourceFileService", sync: true}, {}],

	navImageList: ["wm.ImageList", {width: 24, height: 28, colCount: 10, url: "images/navBtns.png"}, {}],
//	canvasToolbarImageList: ["wm.ImageList", {width: 24, height: 24, colCount: 20, url: "images/canvasToolbarBtns.png"}, {}],
	smallToolbarImageList: ["wm.ImageList", {width: 16, height: 16, colCount: 32, url: "images/smallToolbarBtns.png"}, {}],
	canvasToolbarImageList16: ["wm.ImageList", {width: "16", height: "16", colCount: 22, url: "images/canvasToolbarBtns16.png"}, {}],
	layout: ["wm.Layout", {height: "100%"}, {}, {
		dialog: ["wm.Dialog", {height: "400px", border: "1", borderColor: "#666E80"}, {}],
		
		navigationBar: ["wm.Panel", {_classes: {domNode: ["wm-darksnazzy"]}, height: "29px", border: "0", layoutKind: "left-to-right"}, {}, {
			navBtnHolder: ["wm.Panel", {width: "100%", border: "0", layoutKind: "left-to-right", imageList: "navImageList", horizontalAlign: "left"}, {}, {
			  navigationMenu: ["wm.DojoMenu", {height: "29px", width: "620px",
						      "fullStructure": 
						      [
							{"label" :"ファイル",
							 idInPage: "projectPopupBtn",
							 "children": 
							 [
							      {"label":"新規プロジェクト...",
							       idInPage: "newProjectItem",
							       onClick: "newProjectClick",
							       iconClass: "newProjectItem"},
                                                              {"label":"開く...",
							       idInPage: "openProjectItem",
							       onClick: "openProjectClick",
							       iconClass: "openProjectItem"},
                                                              {"label":"閉じる",
							       idInPage: "closeProjectItem",
							       onClick: "closeClick",
							       iconClass: "closeProjectItem"},
                                                              {"label":"現プロジェクトをコピー...",
							       idInPage: "copyProjectItem",
							       onClick: "copyProjectClick",
							       iconClass: "copyProjectItem"},
                                                              {"label":"現プロジェクトを削除",
							       idInPage: "deleteProjectItem",
							       onClick: "deleteProjectClick",
							       iconClass: "deleteProjectItem"},
                                                              {"label":"エクスポート",
							       idInPage: "exportProjectItem",
							       onClick: "exportClick",
							       iconClass: "exportProjectItem"},
                                                              {"label":"インポート...",
							       idInPage: "importProjectItem",
							       onClick: "importClick",
							       iconClass: "importProjectItem"},
                                                              {"label":"デプロイ...",
							       idInPage: "deployProjectItem",
							       onClick: "deployClick",
							       iconClass: "deployProjectItem"},                                                          
                                                              {"label":"設定...",
							       idInPage: "preferencesItem",
							       onClick: "projectSettingsClick",
							       iconClass: "preferencesItem"}
							 ]},
                                                          {"label":"編集",
							   idInPage: "editPopupBtn",
                                                            "children": [
                                                                {"label":"切り取り",
								 idInPage: "cutItem",
								 onClick: "cutClick",
								 iconClass: "cutItem"},
							        {"label":"コピー",
								 idInPage: "copyItem",
								 onClick: "copyClick",
								 iconClass: "copyItem"},
                                                                {"label":"貼り付け",
								 idInPage: "pasteItem",
								 onClick: "pasteClick",
								 iconClass: "pasteItem"},
							        {"label":"削除",
								 idInPage: "deleteItem",
								 onClick: "deleteClick",
								 iconClass: "deleteItem"},
							        {"label":"元に戻す",
								 idInPage: "undoItem",
								 onClick: "undoClick",
								 iconClass: "undoItem"}]},
							   {"label":"ビュー",
							    idInPage: "viewPopupBtn",
							    "children":  [
								{"label":"キャンバス",
								 idInPage: "canvasItem",
								 onClick: "navGotoDesignerClick",
								 iconClass: "canvasItem"},
							        {"label":"ソース",
								 idInPage: "sourceItem",
								 onClick: "navGotoSourceClick",
								 iconClass: "sourceItem"},
							        {"label":"リソース",
								 idInPage: "resourceItem",
								 onClick: "navGotoResourcesClick",
								 iconClass: "resourceItem"},
							        {"label":"アウトライン",
								 idInPage: "outlineItem",
								 onClick: "outlinedClick",
								 iconClass: "outlineItem"}]},

							    {"label":"挿入",
							     idInPage: "insertPopupBtn",
							     "children":[
							     ]},
							   {"label":"ページ",
							    idInPage: "pagePopupBtn",
							    "children":[
							        {"label":"新規...",
								 idInPage: "newPageItem",
								 onClick: "newPageClick",
								 iconClass: "newPageItem"},
							        {"label":"名前を付けて保存...",
								 idInPage: "saveAsPageItem",
								 onClick: "savePageAsClick",
								 iconClass: "saveAsPageItem"},
							        {"label":"ページをインポート...",
								 idInPage: "importPageItem",
								 onClick: "importProjectClick",
								 iconClass: "importPageItem"},
							        {"label":"ホームページに設定",
								 idInPage: "setHomePageItem",
								 onClick: "makeHomeClick",
								 iconClass: "setHomePageItem"}]},
							    {"label":"サービス",
							     idInPage: "servicesPopupBtn",
							     "children":[
							     ]},

							    {"label":"ヘルプ",
							     idInPage: "helpPopupBtn",
							     "children":[
							         {"label":"チュートリアル",
								  idInPage: "tutorialDocItem",
								  onClick: "linkButtonClick",
								  openLink: "http://dev.wavemaker.com/wiki/bin/jp_wmdoc/%26%2312481%3B%26%2312517%3B%26%2312540%3B%26%2312488%3B%26%2312522%3B%26%2312450%3B%26",
								  openLinkTitle: "WaveMakerチュートリアル"
								 },
							         {"label":"ドキュメント",
								  idInPage: "documentationDocItem",
								  onClick: "linkButtonClick",
								  openLink: "http://dev.wavemaker.com/wiki/bin/JP_Documentation/WebHome",
								  openLinkTitle: "WaveMakerユーザガイド"
								 },
 							         {"label":"コミュニティ",
								  idInPage: "communityDocItem",
								  onClick: "linkButtonClick",
								  openLink: "http://dev.wavemaker.com",
								  openLinkTitle: "WaveMakerコミュニティ"
								 },
							         {"label":"Java (サーバ)ドキュメント",
								  idInPage: "javaServerDocItem",
								  onClick: "linkButtonClick",
								  openLink: "javadoc",
								  openLinkTitle: "WaveMaker Java (サーバ)ドキュメント"
								 },
							         {"label":"JavaScript (クライアント)ドキュメント",
								  idInPage: "clientDocItem",
								  onClick: "linkButtonClick",
								  openLink: "jsdoc",
								  openLinkTitle: "WaveMaker JavaScript (クライアント)ドキュメント"
								 }
							     ]
							    }
						      ]
						     },  {},{}],
			  /*
				nspcr5: ["wm.Spacer", {width: "15px"}, {}],
				projectPopupBtn: ["wm.PopupButton", {width: "55px", caption: "<span style=\"font-weight:bold;padding:4px;\">ファイル</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "180", hint: "プロジェクト管理", imageList: "smallToolbarImageList", height: "29px"}, {}, {
					newProjectItem: ["wm.Item", {caption: "新規プロジェクト...", imageIndex: 17}, {onclick: "newProjectClick"}],
					openProjectItem: ["wm.Item", {caption: "プロジェクトを開く...", imageIndex: 18}, {onclick: "openProjectClick"}],
					closeProjectItem: ["wm.Item", {caption: "プロジェクトを閉じる", imageIndex: 13}, {onclick: "closeClick"}],
					copyProjectItem: ["wm.Item", {caption: "プロジェクトをコピー...", imageIndex: 1}, {onclick: "copyProjectClick"}],
					deleteProjectItem: ["wm.Item", {caption: "プロジェクトを削除", imageIndex: 0}, {onclick: "deleteProjectClick"}],
					exportProjectItem: ["wm.Item", {caption: "プロジェクトをエクスポート", imageIndex: 19}, {onclick: "exportClick"}],
					importProjectItem: ["wm.Item", {caption: "プロジェクトをインポート...", imageIndex: 19}, {onclick: "importClick"}],
					deployProjectItem: ["wm.Item", {caption: "デプロイ...", imageIndex: 3}, {onclick: "deployClick"}],
					preferencesItem: ["wm.Item", {caption: "設定...", imageIndex: 3}, {onclick: "projectSettingsClick"}]
				}],
				editPopupBtn: ["wm.PopupButton", {width: "55px", caption: "<span style=\"font-weight:bold;padding:4px;\">編集</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "120", hint: "ページ編集", imageList: "canvasToolbarImageList16", height: "29px"}, {}, {
					cutItem: ["wm.Item", {caption: "切取り", imageIndex: 2}, {onclick: "cutClick"}],
					copyItem: ["wm.Item", {caption: "コピー", imageIndex: 3}, {onclick: "copyClick"}],
					pasteItem: ["wm.Item", {caption: "貼付け", imageIndex: 4}, {onclick: "pasteClick"}],
					deleteItem: ["wm.Item", {caption: "削除", imageIndex: 5}, {onclick: "deleteClick"}],
					undoItem: ["wm.Item", {caption: "元に戻す", imageIndex: 6}, {onclick: "undoClick"}]
				}],
				viewPopupBtn: ["wm.PopupButton", {width: "65px", caption: "<span style=\"font-weight:bold;padding:4px;\">ビュー</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "120", hint: "ページビュー", imageList: "canvasToolbarImageList16", height: "29px"}, {}, {
					canvasItem: ["wm.Item", {caption: "キャンバス", imageIndex: 21}, {onclick: "navGotoDesignerClick"}],
					sourceItem: ["wm.Item", {caption: "ソース", imageIndex: 20}, {onclick: "navGotoSourceClick"}],
					resourceItem: ["wm.Item", {caption: "リソース", imageIndex: 20}, {onclick: "navGotoResourcesClick"}],
					outlineItem: ["wm.Item", {caption: "アウトライン", imageIndex: 8}, {onclick: "outlinedClick"}]/ *,
					liveLayoutItem: ["wm.Item", {caption: "ライブレイアウト", imageIndex: 7}, {onclick: "refreshLiveData"}]* /
				}],
				insertPopupBtn: ["wm.PopupButton", {width: "70px", caption: "<span style=\"font-weight:bold;padding:4px;\">Insert</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "180", hint: "新しいコンポーネントを挿入", imageList: "smallToolbarImageList", height: "29px"}, {}, {
					
				}],
				pagePopupBtn: ["wm.PopupButton", {width: "65px", caption: "<span style=\"font-weight:bold;padding:4px;\">ページ</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "200", hint: "ページ管理", imageList: "smallToolbarImageList", height: "29px"}, {}, {
					newPageItem: ["wm.Item", {caption: "新規...", imageIndex: 5}, {onclick: "newPageClick"}],
					saveAsPageItem: ["wm.Item", {caption: "名前を付けて保存...", imageIndex: 7}, {onclick: "savePageAsClick"}],
					importPageItem: ["wm.Item", {caption: "ページをインポート...", imageIndex: 11}, {onclick: "importProjectClick"}],
					setHomePageItem: ["wm.Item", {caption: "ホームページに設定", imageIndex: 2}, {onclick: "makeHomeClick"}]
				}],
				servicesPopupBtn: ["wm.PopupButton", {width: "85px", caption: "<span style=\"font-weight:bold;padding:4px;\">サービス</span><img src=\"images/dropArrow.png\"/> ", popupWidth: "180", hint: "Create New Service", imageList: "smallToolbarImageList", height: "29px"}, {}, {
					
				}],
				helpPopupBtn: ["wm.PopupButton", {width: "60px", caption: "<span style=\"font-weight:bold;padding:4px;\">ヘルプ </span><img src=\"images/dropArrow.png\"/>", popupWidth: "250", hint: "ヘルプ"}, {}, {
					tutorialItem: ["wm.Item", {caption: "チュートリアル", openLink: "http://dev.wavemaker.com/wiki/bin/view/WM5_Documentation/Tutorial", openLinkTitle: "WaveMakerチュートリアル"}, {onclick: "linkButtonClick"}],
					documentationItem: ["wm.Item", {caption: "ドキュメント", openLink: "http://dev.wavemaker.com/wiki/bin/view/WM5_Documentation/", openLinkTitle: "WaveMakerユーザガイド"}, {onclick: "linkButtonClick"}],
					communityButtonClick: ["wm.Item", {caption: "コミュニティ", openLink: "http://dev.wavemaker.com", openLinkTitle: "WaveMakerコミュニティ"}, {onclick: "linkButtonClick"}],
					javaApiDocBtn: ["wm.Item", {caption: "Java (サーバ)ドキュメント", openLink: "javadoc", openLinkTitle: "WaveMaker Java (サーバ)ドキュメント"}, {onclick: "linkButtonClick"}],
					jsApiDocBtn: ["wm.Item", {caption: "JavaScript (クライアント)ドキュメント", openLink: "jsdoc", openLinkTitle: "WaveMaker JavaScript (クライアント)ドキュメント"}, {onclick: "linkButtonClick"}]
				}],
				navBarSpacer6: ["wm.Spacer", {width: "24px", margin: "0,10", border: "0"}, {}],
*/
				navTestBtn: ["wm.ToolButton", {width: "75px", hint: "デバッグモードで実行し、FireBug/FireBugに出力する。", caption: "<img src=\"images/runapp_24.png\"/><span style=\"font-weight:bold\">テスト</span>", height: "29px"}, {onclick: "runProjectClick"}],
				navRunBtn: ["wm.ToolButton", {width: "75px", hint: "プロジェクトを実行", caption: "<img src=\"images/runapp_24.png\"/><span style=\"font-weight:bold\">実行</span>", height: "29px"}, {onclick: "runProjectClick"}],
				navBarSpacer7: ["wm.Spacer", {width: "100%", border: "0"}, {}],
				userLabel: ["wm.Label", {_classes: {domNode: ["wm_TextDecoration_Bold", "wm_FontColor_White"]}, width: "250px"}, {}],
				navEditAccountBtn: ["wm.ToolButton", {showing: false, width: "120px", hint: "アカウントの編集", caption: "<img src=\"images/user_settings24.png\"/><span style=\"font-weight:bold\">アカウント情報</span>", height: "29px"}, {onclick: "editAccountClick"}],
				navLogoutBtn: ["wm.ToolButton", {showing: false,width: "100px", hint: "ログアウト", caption: "<img src=\"images/close_24.png\"/><span style=\"font-weight:bold\">ログアウト</span>", height: "29px"}, {onclick: "logoutClick"}]
			}]
		}],
		panel1: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}, {
			benchbevel11: ["wm.Bevel", {border: ""}, {}],
			panel2: ["wm.Panel", {height: "48px", width: "200px", border: "0", verticalAlign: "top", horizontalAlign: "left"}, {}, {
				leftToolbarButtons: ["wm.Panel", {height: "29px", width: "100%", layoutKind: "left-to-right", verticalAlign: "top", border: 0, padding: "0,4"}, {}, {
					nspcr4: ["wm.Spacer", {width: "2px"}, {}],
					designerCanvasBtn: ["wm.ToolButton", {border: "0", borderColor: "#294473", margin: "0", padding: "0,6", height: "100%", width: "56px", caption: "", hint: "キャンバス"}, {onclick: "navGotoDesignerClick"}],
					designerSourceBtn: ["wm.ToolButton", {border: "0", borderColor: "#294473", margin: "0", padding: "0,6", height: "100%", width: "57px", caption: "", hint: "ソース"}, {onclick: "navGotoSourceClick"}],
					designerResourcesBtn: ["wm.ToolButton", {border: "0", borderColor: "#294473", margin: "0", padding: "0,6", height: "100%", width: "79px", caption: "", hint: "リソース"}, {onclick: "navGotoResourcesClick"}]
				}],
				left: ["wm.TabLayers", {_classes: {domNode: ["wm-darksnazzy"]}, border: "0", width: "100%", height: "100%"}, {onchange: "leftTabsChange"}, {
				    mlpal: ["wm.Layer", {_classes: {domNode: ["wm-palette"]}, caption: "パレット"}, {}, {
					benchbevel6: ["wm.Bevel", {border: ""}, {}],
					palette: ["wm.Palette", {height: "100%", border: ""}, {}]
					/*
					paletteSplitter: ["wm.Splitter", {border: "0", layout: "bottom"}, {}],
					componentPalette: ["wm.Palette", {height: "300px", border: ""}, {}]*/
				    }],
				    leftObjects: ["wm.Layer", {caption: "モデル"}, {}, {
					benchbevel5: ["wm.Bevel", {border: ""}, {}],
					label11: ["wm.Label", {height: "22px", width: "100%", caption: "非表示コンポーネント：", border: "", padding: "4"}, {}, {
					    format: ["wm.DataFormatter", {}, {}]
					}],
					tree: ["wm.Tree", {height: "200px", border: "", padding: "4,0,0,0"}, {onselect: "treeSelect"}],
					splitter2: ["wm.Splitter", {border: "0", layout: "top"}, {}],
					label12: ["wm.Label", {height: "22px", width: "100%", caption: "表示コンポーネント：", border: "", padding: "4"}, {}, {
					    format: ["wm.DataFormatter", {}, {}]
					}],
					widgetsTree: ["wm.Tree", {height: "100%", border: "", padding: "4,0,0,0"}, {onselect: "treeSelect"}]
				    }],
				    projects: ["wm.Layer", {caption: "プロジェクト"}, {}, {
					ptoolbar: ["wm.Panel", {height: "29px", border: "0", padding: "4,4", layoutKind: "left-to-right", imageList: "smallToolbarImageList", backgroundColor: "#959DAB"}, {}, {
						    /*projectMorePopupBtn: ["wm.PopupButton", {width: "32px", caption: "<img src=\"images/dropArrow.png\"/>", popupWidth: "150", imageIndex: 14}, {}, {
							newProjectItem: ["wm.Item", {imageIndex: 17, caption: "新規プロジェクト..."}, {onclick: "newProjectClick"}],
							newPageItem: ["wm.Item", {imageIndex: 5, caption: "新規ページ..."}, {onclick: "newPageClick"}],
							closeItem: ["wm.Item", {caption: "閉じる", imageIndex: 13}, {onclick: "closeClick"}],
							getWarItem: ["wm.Item", {caption: "デプロイ...", imageIndex: 3}, {onclick: "deployClick"}],
							exportProjItem: ["wm.Item", {caption: "エクスポート...", imageIndex: 19}, {onclick: "exportClick"}],
							projectCopyItem: ["wm.Item", {caption: "プロジェクトをコピー...", imageIndex: 1}, {onclick: "copyProjectClick"}],
							projectImportItem: ["wm.Item", {caption: "ページをインポート...", imageIndex: 11}, {onclick: "importProjectClick"}],
							projectSettingsItem: ["wm.Item", {caption: "設定...", imageIndex: 3}, {onclick: "projectSettingsClick"}]
							}],*/
						projectNewProjectButton: ["wm.ToolButton", {width: "24px", imageIndex: 17, hint: "新規プロジェクト..."}, {onclick: "newProjectClick"}],
						projectNewPageButton: ["wm.ToolButton", {width: "24px", imageIndex: 5, hint: "新規ページ..."}, {onclick: "newPageClick"}],
						projectOpenSelectedButton: ["wm.ToolButton", {width: "24px", imageIndex: 18, hint: "開く"}, {onclick: "openSelectedProjectPageClick"}],
						projectDeleteButton: ["wm.ToolButton", {width: "24px", imageIndex: 0, hint: "削除..."}, {onclick: "deleteSelectedProjectPageClick"}],
						projectSetHomePageButton: ["wm.ToolButton", {width: "24px", imageIndex: 2, hint: "ホームページに設定"}, {onclick: "makeSelectedHomeClick"}]
						/*projectMorePopupBtn: ["wm.PopupButton", {width: "32px", caption: "<img src=\"images/dropArrow.png\"/>", popupWidth: "150", imageIndex: 14}, {}, {
						    projectCopyItem: ["wm.Item", {caption: "プロジェクトをコイー...", imageIndex: 1}, {onclick: "copyProjectClick"}],
						    projectImportItem: ["wm.Item", {caption: "ページをインポート...", imageIndex: 11}, {onclick: "importProjectClick"}],
						    projectSettingsItem: ["wm.Item", {caption: "設定...", imageIndex: 3}, {onclick: "projectSettingsClick"}]
						    }]*/
						}],
					projectsTree: ["wm.Tree", {height: "100%", border: "0"}, {ondblclick: "projectsTreeDblClick", oninitchildren: "projectsTreeInitChildren", onselect: "projectsTreeSelectionChange"}]
				    }]
				}],

				benchbevel12: ["wm.Bevel", {border: ""}, {}]
			}],
			splitter1: ["wm.Splitter", {border: "0", layout: "left"}, {}],
		tabs: ["wm.Layers", {border: "0", width: "100%", height: "100%"}, {oncanchange: "tabsCanChange", onchange: "tabsChange"}, {
				workspace: ["wm.Layer", {caption: "設計"}, {}, {
					ribbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right", padding: "0,4"}, {}, {
						studioToolbarButtons: ["wm.Panel", {height: "100%", width: "100%", border: "", layoutKind: "left-to-right", imageList: "canvasToolbarImageList16"}, {}, {
							/*pagePopupBtn: ["wm.PopupButton", {width: "32px", caption: "<img src=\"images/dropArrow.png\"/>", popupWidth: "150", imageIndex: 14, imageList: "smallToolbarImageList"}, {}, {
								pageBtnItem4: ["wm.Item", {caption: "新規ページ...", imageIndex: 5}, {onclick: "newPageClick"}],
								pageBtnItem16: ["wm.Item", {caption: "保存", imageIndex: 8}, {onclick: "saveProjectClick"}],
								pageBtnItem6: ["wm.Item", {caption: "名前を付けて保存...", imageIndex: 7}, {onclick: "savePageAsClick"}],
								pageBtnItem9: ["wm.Item", {caption: "ホームページに設定", imageIndex: 2}, {onclick: "makeHomeClick"}]
							}],*/
							pageSaveBtn: ["wm.ToolButton", {width: "24px", imageIndex: 1, hint: "保存"}, {onclick: "saveProjectClick"}],
							toolbarspacer1: ["wm.Spacer", {height: "24px", width: "12px", margin: "0,5"}, {}],
							cutBtn: ["wm.ToolButton", {width: "24px", imageIndex: 2, hint: "切取り"}, {onclick: "cutClick"}],
							copyBtn: ["wm.ToolButton", {width: "24px", imageIndex: 3, hint: "コピー"}, {onclick: "copyClick"}],
							pasteBtn: ["wm.ToolButton", {width: "24px", imageIndex: 4, hint: "貼付け"}, {onclick: "pasteClick"}],
							deleteBtn: ["wm.ToolButton", {width: "24px", imageIndex: 5, hint: "削除"}, {onclick: "deleteClick"}],
							undoBtn: ["wm.ToolButton", {width: "24px", imageIndex: 6, disabled: true}, {onclick: "undoClick"}],
							toolbarspacer2: ["wm.Spacer", {height: "24px", width: "12px", margin: "0,5"}, {}],
							/*liveLayoutBtn: ["wm.ToolButton", {width: "24px", imageIndex: 7, hint: "Liveレイアウト"}, {onclick: "refreshLiveData"}],*/
							outlineBtn: ["wm.ToolButton", {width: "24px", imageIndex: 8, hint: "アウトラインビューの切り替え"}, {onclick: "outlinedClick"}]
						}],
						logoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
					}],
					main: ["wm.Panel", {height: "100%", border: "", layoutKind: "left-to-right", borderColor: "#666E80"}, {}, {
						bench: ["wm.Panel", {width: "100%", border: "1, 0, 0, 0", backgroundColor: "silver", borderColor: "#666E80"}, {}, {
							designer: ["wm.Designer", {height: "100%", width: "100%", backgroundColor: "white", borderColor: "black", border: ""}, {onselect: "designerSelect", onmove: "designerMove"}],
							benchbevel: ["wm.Bevel", {border: ""}, {}],
							status: ["wm.Box", {height: "24px", border: "1, 0, 0, 0", borderColor: "#666E80", backgroundColor: "#424A5A", width: "767px"}, {}]
						}],
						splitter3: ["wm.Splitter", {border: "0", layout: "right"}, {}],
						right: ["wm.Panel", {_classes: {domNode: ["wm-darksnazzy"]}, width: "246px", border: "0"}, {}, {
							componentsTreePanel: ["wm.Panel", {height: "120px", border: "0", showing: false}, {}, {
								componentsToolbar: ["wm.Panel", {height: "31px", border: "0", padding: "1, 0, 0, 0", layoutKind: "left-to-right"}, {}, {
									newVariableButton: ["wm.ToolButton", {width: "32px", hint: "新規変数", caption: "<img src=\"images/wm/variable_24.png\"/>"}, {onclick: "newComponentButtonClick"}],
									newLiveVariableButton: ["wm.ToolButton", {width: "32px", hint: "新規ライブ変数", caption: "<img src=\"images/wm/livevar_24.png\"/>"}, {onclick: "newComponentButtonClick"}],
									newServiceVariableButton: ["wm.ToolButton", {width: "32px", hint: "新規サービス変数", caption: "<img src=\"images/wm/servicevar_24.png\"/>"}, {onclick: "newComponentButtonClick"}],
									newNavigationButton: ["wm.ToolButton", {width: "32px", hint: "新規ナビゲーション", caption: "<img src=\"images/wm/navigation_24.png\"/>"}, {onclick: "newComponentButtonClick"}],
									dashspacer1: ["wm.Spacer", {width: "2px"}, {}],
									deleteComponentButton: ["wm.ToolButton", {width: "32px", hint: "削除", caption: "<img src=\"images/delete_24.png\"/>"}, {onclick: "deleteComponentButtonClick"}]
								}],
								componentsTree: ["wm.Tree", {height: "100%"}, {onselect: "treeSelect", ondblclick: "componentsTreeDblClick"}]
							}],
							splitter3b: ["wm.Splitter", {border: "", showing: false}, {}],
							PIPanel: ["wm.Panel", {height: "100%", border: "0", padding: "5", layoutKind: "left-to-right"}, {}, {
								PIContents: ["wm.Panel", {width: "100%", border: "0"}, {}, {
									propInsContainer: ["wm.Panel", {height: "100%", border: "0"}, {}, {
										PILabelContainer: ["wm.Panel", {height: "25px", border: "0"}, {}, {
											insTop: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}, {
												inspected: ["wm.Label", {height: "100%", width: "100%", caption: "", border: "", padding: "2"}, {}, {
													format: ["wm.DataFormatter", {}, {}]
												}]
											}]
										}],
										PITopBorder: ["wm.Panel", {height: "4px", border: "0", layoutKind: "left-to-right"}, {}, {
											PITopBorderl: ["wm.Panel", {width: "4px", border: "0"}, {}],
											PITopBorderm: ["wm.Panel", {width: "100%", border: "0"}, {}],
											PITopBorderr: ["wm.Panel", {width: "4px", border: "0"}, {}]
										}],
										PIContainer: ["wm.Panel", {height: "100%", border: "0", layoutKind: "left-to-right"}, {}, {
											propsTabs: ["wm.Layers", {border: "0", width: "100%", height: "100%"}, {}, {
												propsLayer: ["wm.Layer", {caption: "PropertiesHO"}, {}, {
													inspector: ["wm.ComponentInspectorPanel", {border: "0", height: "100%", width: "100%"}, {}, {

													}]
												}]
											}]
										}],
										PIBotBorder: ["wm.Panel", {height: "4px", border: "0", layoutKind: "left-to-right"}, {}, {
											PIBotBorderl: ["wm.Panel", {width: "4px", border: "0"}, {}],
											PIBotBorderm: ["wm.Panel", {width: "100%", border: "0"}, {}],
											PIBotBorderr: ["wm.Panel", {width: "4px", border: "0"}, {}]
										}]
									}]
								}]
							}]
							/*,spacer1: ["wm.Spacer", {height: "4px", width: "96px", border: "2", borderColor: "#666E80"}, {}]*/
						}]
					}],
					benchbevel4: ["wm.Bevel", {}, {}]
				}],
				loginLayer: ["wm.Layer", {_classes: {domNode: ["wm-darksnazzy"]}, caption: "Login", margin: "100,60,0,60", height: "325px", width: "250px"}, {}, {
		  loginPage: ["wm.PageContainer", {pageName:  "", height: "100%", width: "100%"}, {}]
		}],
		deploymentLayer: ["wm.Layer", {caption: "Deployment"}, {}, {
		    deploymentPage: ["wm.PageContainer", {pageName:  "", height: "100%", width: "100%"}, {}]
		}],
		resourcesTab: ["wm.Layer", {caption: "Resources"}, {}, {
		                    resourcesPage: ["wm.PageContainer", {loadParentFirst: true, pageName: "ResourceManager", height: "100%", width: "100%"}, {}]
				}],
				sourceTab: ["wm.Layer", {_classes: {domNode: ["wm-darksnazzy"]}, caption: "IDE"}, {}, {
				    /*
					sourceRibbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right", imageList: "smallToolbarImageList", padding: "0,4"}, {}, {
						sourcePageSaveBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "保存", imageIndex: 8}, {onclick: "saveProjectClick"}],
						sourceToolbarSpacerPanel: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}],
						sourceLogoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
					}],*/
					sourceTabs: ["wm.TabLayers", {border: "0", width: "100%", height: "100%"}, {onchange: "sourceTabsChange", oncanchange: "sourceTabsCanChange"}, {
					    scriptLayer: ["wm.Layer", {caption: "スクリプト"}, {}, {
						benchbevel8: ["wm.Bevel", {}, {}],
						scriptRibbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right", imageList: "smallToolbarImageList", padding: "0,4"}, {}, {
						    scriptPageSaveBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "保存", imageIndex: 8}, {onclick: "saveScriptClick"}],
						    scriptPageImportBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "インポート", imageIndex: 25}, {onclick: "importJavascriptLibrary"}],
						    scriptToolbarSpacerPanel: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}],
						    scriptLogoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
						}],
						editArea: ["wm.EditArea", {width: "100%", height: "100%"}, {}]
					    }],
						cssLayer: ["wm.Layer", {caption: "CSS"}, {}, {
							benchbevel9: ["wm.Bevel", {}, {}],
							cssRibbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right", imageList: "smallToolbarImageList", padding: "0,4"}, {}, {
							    cssPageSaveBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "保存", imageIndex: 8}, {onclick: "saveCssClick"}],
							    cssPageImportBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "インポート", imageIndex: 25}, {onclick: "importCssLibrary"}],
							    cssToolbarSpacerPanel: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}],
							    cssLogoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
							}],
							cssPageLabel: ["wm.Label", {caption: "ページCSS", height: "18px", border: 0}, {}, {
								format: ["wm.DataFormatter", {}, {}]
							}],
							cssEditArea: ["wm.EditArea", {width: "100%", height: "100%", syntax: "css"}, {}],
							cssSplitter: ["wm.Splitter", {layout: "bottom"}, {}],
							cssAppPanel: ["wm.Panel", {height: "300px", border: "0"}, {}, {
								cssAppLabel: ["wm.Label", {caption: "アプリケーションCSS", height: "18px", border: 0}, {}, {
									format: ["wm.DataFormatter", {}, {}]
								}],
								appCssEditArea: ["wm.EditArea", {width: "100%", height: "100%", syntax: "css"}, {}]
							}]
						}],
						markupLayer: ["wm.Layer", {caption: "マークアップ"}, {}, {
							benchbevel10: ["wm.Bevel", {}, {}],
							markupRibbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right", imageList: "smallToolbarImageList", padding: "0,4"}, {}, {
							    markupPageSaveBtn: ["wm.ToolButton", {width: "24px", margin: "0", hint: "保存", imageIndex: 8}, {onclick: "saveMarkupClick"}],
							    markupToolbarSpacerPanel: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}],
							    markupLogoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
							}],
							markupEditArea: ["wm.EditArea", {width: "100%", height: "100%", syntax: "html"}, {}]
						}],
						widgets: ["wm.Layer", {caption: "ウィジェット"}, {}, {
							benchbevel13: ["wm.Bevel", {}, {}],
							widgetsHtml: ["wm.Html", {width: "100%", height: "100%", border: 0, padding: "4, 0, 0, 4"}, {}]
						}],
						appsource: ["wm.Layer", {caption: "アプリケーション"}, {}, {
							benchbevel14: ["wm.Bevel", {}, {}],
							appsourceHtml: ["wm.Html", {width: "100%", height: "100%", border: 0, padding: "4, 0, 0, 4"}, {}]
						}],
					    logs: ["wm.Layer", {caption: "サーバログ"}, {}, {
							benchbevel14: ["wm.Bevel", {}, {}],
							logViewer: ["wm.PageContainer", {loadParentFirst: true, pageName: "LogViewer",  width: "100%", height: "100%"}]
						}],
						diagnosticsTab: ["wm.Layer", {caption: "診断"}, {}, {
							diagnosticsPane: ["wm.PageContainer", {loadParentFirst: true, pageName: "Diagnostics", width: "100%", height: "100%"}, {}]
						}]
					}]
				}]/*,
				servicesTab: ["wm.Layer", {caption: "サービス", layoutKind: "left-to-right"}, {}, {
					servicesPane: ["wm.PageContainer", {pageName: "Services", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				javaServiceEditor: ["wm.Layer", {caption: "Javaサービスエディタ", layoutKind: "left-to-right"}, {}, {
					javaServicePage: ["wm.PageContainer", {pageName: "JavaEditor", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				dataObjectsTab: ["wm.Layer", {caption: "データモデル"}, {}, {
					dataObjectsPane: ["wm.PageContainer", {pageName: "DataObjectsEditor", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				liveViewsEditor: ["wm.Layer", {caption: "ライブビュー"}, {}, {
					liveViewPageContainer: ["wm.PageContainer", {pageName: "LiveViewEditor", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				hqlQueryEditor: ["wm.Layer", {caption: "HQLクエリエディタ"}, {}, {
					hqlQueryPage: ["wm.PageContainer", {pageName: "QueryEditor", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				securityTab: ["wm.Layer", {caption: "セキュリティ"}, {}, {
					securityPane: ["wm.PageContainer", {pageName: "Security", deferLoad: true, border: "0", width: "100%", height: "100%"}, {}]
				}],
				apiDocTab: ["wm.Layer", {caption: "IDE"}, {}, {
					apiRibbon: ["wm.Panel", {height: "29px", border: "0", layoutKind: "left-to-right"}, {}, {
						apiToolbarSpacerPanel: ["wm.Panel", {height: "100%", width: "100%", border: "0", layoutKind: "left-to-right"}, {}],
						apiLogoBottomHolder: ["wm.Panel", {width: "221px", border: "0"}, {}]
					}],
					apiTabs: ["wm.TabLayers", {border: "0", width: "100%", height: "100%"}, {}, {
						apiTab: ["wm.Layer", {caption: "JavaScript (クライアント)リファレンス"}, {}, {
							javadocFrame: ["wm.IFrame", {source: "/wavemaker/jsdoc/", width: "100%", height: "100%"}, {}]
						}],
						javadocTab: ["wm.Layer", {caption: "Java (サーバ)リファレンス"}, {}, {
							javadocFrame1: ["wm.IFrame", {source: "/wavemaker/javadoc/", width: "100%", height: "100%"}, {}]
						}],
						diagnosticsTab: ["wm.Layer", {caption: "診断"}, {}, {
							//diagnosticsPane: ["wm.PageContainer", {pageName: "Diagnostics", width: "100%", height: "100%"}, {}]
						}]
					}]
				}]
				*/
			}]
		}],
		console: ["wm.Box", {height: "96", showing: false}, {}],
		markup: ["wm.Html", {height: "0", showing: false}, {}]
		/*,
		footer: ["wm.Html", {height: "18px", html: "Copyright &copy; 2008 <a target=\"_blank\" href=\"http://www.wavemaker.com\" style=\"color:#b4d5f0;\">WaveMaker Software</a>, Studio Version: wmVersionNumber", showing: false}, {}]*/
	}]
}
